﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Interop;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfNotifyIcon
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		// Do referencí je třeba přidat System.Drawing
		private System.Drawing.Icon ikona = null;
		private System.Windows.Interop.HwndSource hwndSource;

		public MainWindow()
		{
			InitializeComponent();
		}

		private void OnLoaded(object sender, RoutedEventArgs e)
		{
			this.ikona = Properties.Resources.Pivo;
			this.hwndSource = (HwndSource)PresentationSource.FromVisual(this);
			this.hwndSource.AddHook(WindowProc);
			VytvoritNotifyIcon();
		}

		private IntPtr WindowProc(IntPtr hwnd, int msg, IntPtr wParam, IntPtr lParam, ref bool handled)
		{
			switch (msg)
			{
				case WinApi.NativeMethods.wm_notify_ikona:
					int llp = lParam.ToInt32() & 0x0000FFFF;
					switch (llp)
					{
						case WinApi.NativeMethods.WM_LBUTTONUP:
							if (IsVisible)
								Hide();
							else
								Show();
							break;
					}
					break;
			}
			return IntPtr.Zero;
		}

		private void VytvoritNotifyIcon()
		{
			WinApi.NativeMethods.NOTIFYICONDATA nid = new WinApi.NativeMethods.NOTIFYICONDATA();
			nid.hIcon = ikona.Handle;
			nid.hWnd = hwndSource.Handle;
			nid.uID = 1;
			nid.szTip = "Vývoj WMP";
			nid.uFlags = WinApi.NativeMethods.NIF_ICON | WinApi.NativeMethods.NIF_MESSAGE | WinApi.NativeMethods.NIF_TIP;
			nid.uCallbackMessage = WinApi.NativeMethods.wm_notify_ikona;
			nid.uFlags |= WinApi.NativeMethods.NIF_SHOWTIP;
			if (WinApi.UnsafeNativeMethods.Shell_NotifyIcon(WinApi.NativeMethods.NIM_ADD, nid) == 0)
				throw new System.ComponentModel.Win32Exception();
			nid.uTimeoutOrVersion = WinApi.NativeMethods.NOTIFYICON_VERSION_4;
			if (WinApi.UnsafeNativeMethods.Shell_NotifyIcon(WinApi.NativeMethods.NIM_SETVERSION, nid) == 0)
				throw new System.ComponentModel.Win32Exception();
		}

		private void ZrusitNotifyIcon()
		{
			WinApi.NativeMethods.NOTIFYICONDATA nid = new WinApi.NativeMethods.NOTIFYICONDATA();
			nid.hWnd = hwndSource.Handle;
			nid.uID = 1;
			if (WinApi.UnsafeNativeMethods.Shell_NotifyIcon(WinApi.NativeMethods.NIM_DELETE, nid) == 0)
				throw new System.ComponentModel.Win32Exception();
		}

		private void OnClosing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			ZrusitNotifyIcon();
		}
	}
}
